
/*
 * Dichiarazione della classe
 */
public class Counter 
{

    /* 
     * ------ Attributi della classe .--------  */
     
    /* Nota: tipicamente gli attributi si definiscono con visibilit private
     * in modo che non siano accessibili in maniera diretta ma soltanto
     * attraverso i metodo get e set (incapsulamento).
     *
     */
    private int val;



  /* ------ Metodi della classe ------------*/

	
	/*  Costruttori della classe	*/

	// Costruttore senza parametri
	
    public Counter() 
    {
           val=0; //inizializzazione del campo della classe
    }
     
    // Costruttore con parametro intero
    
    public Counter(int v) 
    {
           
           setVal(v); 	//inizializzazione del campo della classe con il valore passato come parametro
    }


	/*  Metodi di accesso agli attributi	*/
	 
	// Lettura del campo val
	
	public int getVal() {
		
		return val;
		
	}
	
    // Scrittura del campo val
    
    public void setVal(int v)
    {
            val=v;
    }
    
    /* Metodi di modifica dello stato del contatore	
     *	Si noti la tecnica di method overloading consentita da Java:
     *	Definiamo due metodi con lo stesso nome, ma con signature differente (cambiano gli argomenti del metodo)
     **/
    
    
    // Incremento di una unit 
    
    public void inc()	{
    	
    	val++;
    	
    }
    
    // Incremento di un intero passato come parametro 
    
    public void inc (int n) {
    	
    	val = val + n;
    	
    }
    
    // Reset del contatore a zero
    
    public void reset() {
    	
    	val = 0;
    	
    }

}  